bool input(0) RUN;
bool input(1) HOLD;


double parameter(0) amp; //amplituda gen. signalu
int parameter(1) dataset; //volba datasetu - poc. bitu MLS generatoru
double parameter(2) w0; //sirka pasma bud. signalu
int parameter(3) nit; //pocet iteraci periodicke PRBS sekvence, realne cislo se orizne na floor(nint)

double output(0) y; //generovany vystup
bool output(1) ID; //identifikace bezi
double output(2) ttf; //time to finish - zbyvajici cas experimentu
double output(3) yy4; //kts - pocet vzorku odpovidajici jednomu bitu ML sekvence
double output(4) yy5; //realna sirka pasma po zaokrouhleni na celociselne kts
double output(5) act_int; //aktualni aktivni iterace, 0 v pripade vypnuteho generatoru, nit_act v pripade beziciho

const int num_ds=5; //pocet data setu s MLS sekvencemi - pozor, musi odpovidat poctu CNA bloku ve schematu


double aa[num_ds][16400]; //globalni promenna s generovanymi daty, naplni se v initu, POZOR, pole musi byt vetsi nez nejdelsi sekvence v CNA blocich
int index; //index pulzu v bezrozmerne prbs posloupnosti
int index2;//index pulzu signalu s konkretni w0, v ramci jedne hodnoty bezrozmerne sekvence mam kts pulzu
int delka[num_ds]; //delka jednotlivych datasetu, naplni se v initu
int ds_act; //aktualni zapnuty dataset
int nit_act; //aktualni cislo iterace v prubehu generovani
//int nit_rnd; //zaokrouhlena hodnota poctu iteraci pouzivana interne, zavedeno pro osetreni chyb kdyz se do bloku zada nit 0 nebo zaporne cislo

bool RUN_TMP;
bool GEN_EN;
double Ts; //perioda vzorkovani tasku
double kTs; //pocet vzorku MLS signalu se stejnou hodnotou



int init(void)
{
	int i,j;
	
	

	
	for (i=0;i<num_ds;i++)
	{
		//delka[i]=GetExtDouble(".CNA4:acn["+long2str(i)+"][0]"); //na prvnim znaku ocekavam delku sekvence
		delka[i]=GetExtDouble(".CNA"+long2str(i+1)+":acn[0]"); //na prvnim znaku ocekavam delku sekvence

		for (j=1;j<(delka[i]+1);j++)
		{
			aa[i][j-1]=GetExtDouble(".CNA"+long2str(i+1)+":acn["+long2str(j)+"]"); //nacteni vektoru z CNA, prvky jsou z csv souboru
		}

	}

	
		


	RUN_TMP=0;
	index=0;
	index2=0;

	if ((dataset>0)&&(dataset<num_ds))
	{
		ds_act=dataset;
	}
	else
	{
		ds_act=0;
	}

	Ts=GetPeriod();
	kTs=ceil(2.094395102393195/w0/Ts); //kTs=2*pi/(3*w0*Ts)
	yy4=kTs;
	yy5=2.094395102393195/(kTs*Ts);

	//ttf=delka[ds_act]*kTs*Ts;
	//V4
	ttf=delka[ds_act]*kTs*Ts*nit;
	nit_act=0;
	


	return 0;
}

int parchange(void)
{
	

	if ((dataset>0)&&(dataset<num_ds))
	{
		ds_act=dataset;
	}
	else
	{
		ds_act=0;
	}


	kTs=ceil(2.094395102393195/w0/Ts); //kTs=2*pi/(3*w0*Ts)
	yy4=kTs;
	yy5=2.094395102393195/(kTs*Ts);
	
	//ttf=delka[ds_act]*kTs*Ts;
	//V4
	ttf=delka[ds_act]*kTs*Ts*nit;
	nit_act=0;

	return 0;
}




int main(void)
{	
	//LOGIKA
	if (RUN==1&RUN_TMP==0&&GEN_EN==0&&nit>0) //generator nebezi a bylo nahozeno RUN, prechod do stavu GEN=EN
	{
		GEN_EN=1;
		index=0;
		index2=0;
		nit_act=1;
	}
	if (HOLD==1||((index>=delka[ds_act]) && (nit_act==nit)) )  //Zastaveni vstupem HOLD anebo dobehnuti zvolene sekvence s danym poctem opakovani
	{
		GEN_EN=0;
		index=0;
		index2=0;
		nit_act=0;
	}
	
	if (GEN_EN==1&&(index>=(delka[ds_act])&&(nit_act<nit)) )   //Preteceni indexu sekvence a nejsem v posledni iteraci, inkrementace citace a vynulovani indexu
	{
		nit_act++;
		index=0;
		index2=0;
	}
	
	


	//GENEROVANI

	if (GEN_EN==1)
	{
		y=amp*(2*aa[ds_act][index]-1);
		index2++;
		if (index2==kTs)
		{
			index2=0;
			index++;
		}
		
		ttf=(delka[ds_act]-index)*kTs*Ts+(nit-nit_act)*delka[ds_act]*kTs*Ts;

	}
	else
	{
		y=0;
		ttf=delka[ds_act]*kTs*Ts*nit;
	}


//	ttf=(delka[ds_act]-index)*kTs*Ts;
	//V4


	act_int=nit_act;
	
	ID=GEN_EN;

	RUN_TMP=RUN;
	return 0;
}
